echo off
REM ****************************************************** {COPYRIGHT-TOP} ***
REM Licensed Materials - Property of IBM
REM 5724-M07, 5698-A77
REM
REM (C) Copyright IBM Corp. 2006 All Rights Reserved.
REM
REM US Government Users Restricted Rights - Use, duplication, or
REM disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
REM ****************************************************** {COPYRIGHT-END} ***
REM ------------------------------------------------------------------------------
REM
REM FTP for BAT
REM
REM ------------------------------------------------------------------------------

REM ------------------------------------------------------------------------------
REM If an error occured during one of the file transfers for this run, 
REM then skip the other transfers
REM ------------------------------------------------------------------------------
if "%transferErrorOccured%"=="true" goto end

set ftpTempFile=%logFileDir_value%\tmpFTPCmds
set ftpTempOutput=%logFileDir_value%\tmpFTPOutput
erase %ftpTempFile% 2> nul
erase %ftpTempOutput% 2> nul
set fileToTransfer=%1
if "%ftDebug%"== "true" echo FTP: transferring %fileToTransfer%

if "%dlaConfirm%"=="true" goto confirmedTransfer

:nonConfirmedTransfer
REM ------------------------------------------------------------------------------
REM Non confirmed Transfer is easiest
REM ------------------------------------------------------------------------------
if "%ftDebug%"== "true" echo performing non-confirmed transfer
set ftpNonConfirmedTemplate=%TemplateDir%\DLA_FileTransfer_BAT_FTP_NonConfirmed.template
%javaCmd% com.ibm.management.soa.dla.filetransfer.TemplateProcessor %ftpNonConfirmedTemplate% %ftpTempFile% %host_value% %userid_value% %password_value% %targetdir_value% %fileToTransfer%
if errorlevel 1 goto error1
ftp -n -s:%ftpTempFile% > %ftpTempOutput%
REM ------------------------------------------------------------------------------
REM FTP will return with errorlevel 0 even if the transfer failed. So
REM We need to check for errors by looking at transfer results.
REM ------------------------------------------------------------------------------
%javaCmd% com.ibm.management.soa.dla.filetransfer.FTPOutputAnalyzer %ftpTempOutput% 250 2
if errorlevel 1 goto error2
if "%ftDebug%"== "true" echo %fileToTransfer% transferred successfully
erase %ftpTempFile%
erase %ftpTempOutput%
%javaCmd% com.ibm.management.soa.dla.filetransfer.MessageLogger TRANSFER_SUCCESSFUL INFO %fileToTransfer% %host_value%
erase %fileToTransfer%
goto end

:confirmedTransfer
REM ------------------------------------------------------------------------------
REM Confirmed transfer involves a couple of steps
REM    Step 1 - FTP file (but do not rename it yet) and download
REM             the file that was just uploaded to a temp file.
REM    Step 2 - Compare file being uploaded to the temp file.
REM    Step 3 - If compare is good, use FTP to rename file on host.  
REM             If it fails, leave the partial file on host to aid in problem
REM             determination. If the partial file is not deleted manually
REM             on the host, it will be deleted during the next DLA run. 
REM ------------------------------------------------------------------------------
if "%ftDebug%"== "true" echo performing confirmed transfer
%javaCmd% com.ibm.management.soa.dla.filetransfer.MessageLogger CONFIRM_TRANSFER_STARTED INFO
set ftpConfirmedTemplate1=%TemplateDir%\DLA_FileTransfer_BAT_FTP_ConfirmedUpload.template
set ftpConfirmedTemplate2=%TemplateDir%\DLA_FileTransfer_BAT_FTP_ConfirmedRename.template
set ftpTempDownloadFile=%logFileDir_value%\tmpFtpDownloadFile
%javaCmd% com.ibm.management.soa.dla.filetransfer.TemplateProcessor %ftpConfirmedTemplate1% %ftpTempFile% %host_value% %userid_value% %password_value% %targetdir_value% %fileToTransfer% %ftpTempDownloadFile%
if errorlevel 1 goto error1
ftp -n -s:%ftpTempFile% > %ftpTempOutput%
REM ------------------------------------------------------------------------------
REM FTP will return errorlevel 0 even if the transfer failed. So
REM We need to check for errors by looking at transfer results.
REM ------------------------------------------------------------------------------
%javaCmd% com.ibm.management.soa.dla.filetransfer.FTPOutputAnalyzer %ftpTempOutput% 226
if errorlevel 1 goto error2
erase %ftpTempOutput%

REM - Compare the files
fc %ftpTempDownloadFile% %fileToTransfer% > nul
if errorlevel 1 goto error3
erase %ftpTempDownloadFile%
%javaCmd% com.ibm.management.soa.dla.filetransfer.MessageLogger CONFIRM_SUCCESSFUL INFO %fileToTransfer%

REM - Rename the file on the host
%javaCmd% com.ibm.management.soa.dla.filetransfer.TemplateProcessor %ftpConfirmedTemplate2% %ftpTempFile% %host_value% %userid_value% %password_value% %targetdir_value% %fileToTransfer%
if errorlevel 1 goto error1
ftp -n -s:%ftpTempFile% > %ftpTempOutput%
REM ------------------------------------------------------------------------------
REM FTP will return errorlevel 0 even if the transfer failed. So
REM We need to check for errors by looking at transfer results.
REM ------------------------------------------------------------------------------
%javaCmd% com.ibm.management.soa.dla.filetransfer.FTPOutputAnalyzer %ftpTempOutput% 250
if errorlevel 1 goto error4
if "%ftDebug%"== "true" echo %fileToTransfer% transferred successfully
erase %ftpTempFile%
erase %ftpTempOutput%
%javaCmd% com.ibm.management.soa.dla.filetransfer.MessageLogger TRANSFER_SUCCESSFUL INFO %fileToTransfer% %host_value%
erase %fileToTransfer%
goto end

REM ------------------------------------------------------------------------------
REM Error section
REM     error1 - error occured processing template
REM     error2 - error occured processing ftp command
REM     error3 - error occured when comparing files
REM     error4 - error occured doing ftp rename on remote host
REM ------------------------------------------------------------------------------
:error1
set transferErrorOccured=true
if "%ftDebug%"=="true" echo Error occured while processing template
goto end

:error2
set transferErrorOccured=true
if "%ftDebug%"=="true" echo Error occured running ftp command
move %ftpTempOutput% %ftpTempOutput%.%_TIME_Value%
%javaCmd% com.ibm.management.soa.dla.filetransfer.MessageLogger FILE_TRANSFER_FAILED ERROR %ftpTempOutput%.%_TIME_Value%
goto end

:error3
set transferErrorOccured=true
if "%ftDebug%"=="true" echo Files do not match
%javaCmd% com.ibm.management.soa.dla.filetransfer.MessageLogger FILE_COMPARE_MISMATCH ERROR %fileToTransfer% %host_value%
erase %ftpTempDownloadFile%
goto end

:error4
set transferErrorOccured=true
if "%ftDebug%"=="true" echo Error occured running ftp command
move %ftpTempOutput% %ftpTempOutput%.%_TIME_Value%
%javaCmd% com.ibm.management.soa.dla.filetransfer.MessageLogger FILE_TRANSFER_RENAME_FAILED ERROR %fileToTransfer%.partial %host_value%
goto end

REM ------------------------------------------------------------------------------
REM End script
REM ------------------------------------------------------------------------------
:end
