#!/bin/sh
# ****************************************************** {COPYRIGHT-TOP} ***
# Licensed Materials - Property of IBM
# 5724-M07, 5698-A77
#
# (C) Copyright IBM Corp. 2006 All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication, or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# ****************************************************** {COPYRIGHT-END} ***
# ------------------------------------------------------------------------------
#
# SFTP for sh script
#
# ------------------------------------------------------------------------------


# ------------------------------------------------------------------------------
# If an error occured during one of the file transfers for this run,
# then skip the remaining transfers
# ------------------------------------------------------------------------------
if [ "$transferErrorOccured" = "true" ]
then
  return
fi

fileToTransfer=$1
if [ "$fileToTransfer" = "" ]
then
  fileToTransfer=$f
fi

if [ "$ftDebug" = "true" ] ;then echo "FTP: transferring file $fileToTransfer" ;fi

baseFileName=`basename $fileToTransfer`

# ------------------------------------------------------------------------------
# Transfer the file
# ------------------------------------------------------------------------------
TransferFile ()
{
  if [ "$ftDebug" = "true" ] ;then echo "Performing transfer" ;fi
  sftpTempFile=$logFileDir_value/tmpSFTPCmds
  sftpTempOutput=$logFileDir_value/tmpSFTPOutput
  sftpTemplate=$templateDir/DLA_FileTransfer_SH_SFTP.template
  rm $sftpTempFile 2> /dev/null
  rm $sftpTempOutput 2> /dev/null
  $javaCmd -cp $classpath com.ibm.management.soa.dla.filetransfer.TemplateProcessor $sftpTemplate $sftpTempFile $targetDir_value $fileToTransfer
  if [ $? -ne 0 ]
  then
    if [ "$ftDebug" = "true" ] ;then echo "Error occured while processing template" ;fi
    transferErrorOccured=true
    return
  fi

  sftp -b $sftpTempFile $userid_value@$host_value > $sftpTempOutput 2>&1
  if [ $? -ne 0 ]
  then
    if [ "$ftDebug" = "true" ] ;then echo "Error occured while transferring file" ;fi
    transferErrorOccured=true
    echo $_TIME_value
    mv $sftpTempOutput $sftpTempOutput.$_TIME_value
    $javaCmd -cp $classpath com.ibm.management.soa.dla.filetransfer.MessageLogger FILE_TRANSFER_FAILED ERROR $sftpTempOutput.$_TIME_value
    return
  fi

  $javaCmd -cp $classpath com.ibm.management.soa.dla.filetransfer.MessageLogger TRANSFER_SUCCESSFUL INFO $fileToTransfer $host_value
  
  rm $sftpTempFile 2> /dev/null
  rm $sftpTempOutput 2> /dev/null
  rm $fileToTransfer
}


TransferFile
