@echo off
REM ****************************************************** {COPYRIGHT-TOP} ***
REM Licensed Materials - Property of IBM
REM 5724-M07, 5698-A77, 5698-B16
REM
REM (C) Copyright IBM Corp. 2006, 2007 All Rights Reserved.
REM
REM US Government Users Restricted Rights - Use, duplication, or
REM disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
REM ****************************************************** {COPYRIGHT-END} ***
REM ------------------------------------------------------------------------------
REM
REM WSRR DLA Process
REM
REM ------------------------------------------------------------------------------

setlocal

REM ------------------------------------------------------------------------------
REM Set the following 2 variables to match your environment
REM    WAS_BIN - Set this to the WebSphere bin directory
REM    WSRR_CLIENT_DIR - Set this to the WSRR directory containing the
REM                      ServiceRegistryClient.jar
REM
REM If either of these directory paths contain a space (e.g.
REM  C:\Program Files\IBM\WebSphereServiceRegistry),  do not put
REM  double quotes around the path.  For example, just specify
REM
REM      set WSRR_CLIENT_DIR=C:\Program Files\IBM\WebSphereServiceRegistry
REM ------------------------------------------------------------------------------
set WAS_BIN=
set WSRR_CLIENT_DIR=

set WSRR_DLA_BIN_DIR=%~dp0
set WSRR_DLA_JAR_DIR=%WSRR_DLA_BIN_DIR%\..\jars

REM ------------------------------------------------------------------------------
REM Parse options:
REM    -c indicates that a confirm of the file transfer is be performed.
REM    -d run DLA only. Do not run file transfer script.
REM    -o Specifies the name of the DLA configuration properties file
REM    -r Force a refresh discovery.
REM    -p Specifies the protocol for file transfer
REM ------------------------------------------------------------------------------

set dlaConfirmOption=
set runFileTransfer=true
:processArgs
if "%1"=="" goto main
if "%1"=="-c" goto processCOption
if "%1"=="-d" goto processDOption
if "%1"=="-o" goto processOOption
if "%1"=="-r" goto processROption
if "%1"=="-p" goto processPOption

REM Instead of printing syntax here, we will let the DLA program handle it.
shift
set runFileTransfer=false
goto processArgs

:processCOption
set dlaConfirmOption=-c
shift
goto processArgs

:processDOption
set runFileTransfer=false
shift
goto processArgs

:processOOption
REM Instead of printing syntax here, we will let the DLA program handle it.
if "%2"=="" goto main
shift
shift
goto processArgs

:processROption
shift
goto processArgs

:processPOption
REM Instead of printing syntax here, we will let the DLA program handle it.
if "%2"=="" goto main
set ftProtocol=%1 %2
shift
shift
goto processArgs

goto main

:main
REM ------------------------------------------------------------------------------
REM Set dladebug to true for extra debug information
REM ------------------------------------------------------------------------------
set dladebug=false

REM ------------------------------------------------------------------------------
REM Setup the WAS environment
REM ------------------------------------------------------------------------------
call "%WAS_BIN%\setupCmdLine.bat" > nul
cd %WSRR_DLA_BIN_DIR%

REM The following line will setup access to the WAS JVM
set path=%WAS_PATH%;%PATH%
set dla_classpath=%WAS_CLASSPATH%;.;%WSRR_DLA_JAR_DIR%\wsrr_dla.jar;%WSRR_CLIENT_DIR%\ServiceRegistryClient.jar;%WSRR_DLA_JAR_DIR%\dl_core.jar;%WSRR_DLA_JAR_DIR%\idml_schema_2.4.jar;%WSRR_DLA_JAR_DIR%\tesmagent.jar;%WSRR_DLA_JAR_DIR%\com.ibm.management.soa.utils.jar;%WSRR_DLA_JAR_DIR%\jlog.jar
if "%dladebug%"=="true" echo Starting DLA...
java "%CLIENTSAS%" -Djava.security.auth.login.config=file:"%USER_INSTALL_ROOT%\properties\wsjaas_client.conf" -Djava.ext.dirs="%WAS_HOME%\classes;%WAS_HOME%\java\jre\lib\ext;%WAS_HOME%\lib"  -classpath "%dla_classpath%" com.ibm.management.soa.dla.wsrr.WSRRDiscoveryLibraryAdapter %*
if errorlevel 1 goto error1

REM Call the file transfer process unless the -d option was specified
if "%runFileTransfer%"=="false" goto end
if "%dladebug%"=="true" echo Starting File Transfer Process...
call DLA_FileTransfer %dlaConfirmOption% %ftProtocol%

goto end

REM ------------------------------------------------------------------------------
REM Error section
REM     error1 - The DLA returned with non-zero errorlevel
REM ------------------------------------------------------------------------------
:error1
REM The dla should have logged the error so we will just echo a message if debug is on
if "%dladebug%"=="true" echo ERROR: DLA program encountered error. Check DLA logs for more information.
goto end

REM ------------------------------------------------------------------------------
REM End script
REM ------------------------------------------------------------------------------
endlocal
:end

